---
title: Magnetometer
slug: Web/API/Magnetometer
tags:
  - API
  - Generic Sensor API
  - Interface
  - Magnetometer
  - Reference
  - Sensor
  - Sensor APIs
  - Sensors
---
<div>{{APIRef("Generic Sensor API")}}</div>

<p><span class="seoSummary">The <strong><code>Magnetometer</code></strong> interface of the <a href="/docs/Web/API/Sensor_APIs">Sensor APIs</a> provides information about the magnetic field as detected by the device’s primary magnetometer sensor. </span></p>

<p>To use this sensor, the user must grant permission to the <code>'magnetometer'</code> device sensor through the {{domxref('Permissions')}} API.</p>

<p>If a feature policy blocks use of a feature, it's because your code is inconsistent with the policies set on your server. This is not something that would ever be shown to a user. See {{httpheader('Feature-Policy')}} for implementation instructions.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("Magnetometer.Magnetometer()")}}</dt>
 <dd>Creates a new <code>Magnetometer</code> object.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref('Magnetometer.x')}} {{readonlyinline}}</dt>
 <dd>Returns a double containing the magnetic field around the device's x axis.</dd>
 <dt>{{domxref('Magnetometer.y')}} {{readonlyinline}}</dt>
 <dd>Returns a double containing the magnetic field around the device's y axis.</dd>
 <dt>{{domxref('Magnetometer.z')}} {{readonlyinline}}</dt>
 <dd>Returns a double containing the magnetic field around the device's z axis.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>The magnetometer is typically read in the {{domxref('Sensor.onreading')}} event callback. In the example below this occurs sixty times a second.</p>

<pre class="brush: js">let magSensor = new Magnetometer({frequency: 60});

magSensor.addEventListener('reading', e =&gt; {
  console.log("Magnetic field along the X-axis " + magSensor.x);
  console.log("Magnetic field along the Y-axis " + magSensor.y);
  console.log("Magnetic field along the Z-axis " + magSensor.z);
});
magSensor.start();</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Generic Sensor')}}</td>
   <td>{{Spec2('Generic Sensor')}}</td>
   <td>Defines sensors in general.</td>
  </tr>
  <tr>
   <td>{{SpecName('Magnetometer','#magnetometer-interface','Magnetometer')}}</td>
   <td>{{Spec2('Magnetometer')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Magnetometer")}}</p>
